"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.InitManager = void 0;
var logger = require("../utils/logger");
var urlParser = require("../utils/url-parser");
var msg = require("./init-message");
var fs = require("fs-extra");
var path = require("path");
// import * as bluebird from "bluebird";
var init_error_1 = require("../error/init-error");
var download_manager_1 = require("../utils/download-manager");
var package_type_1 = require("../utils/package-type");
var InitManager = /** @class */ (function () {
    function InitManager() {
        this.downloadManager = new download_manager_1.DownloadManager();
    }
    InitManager.prototype.init = function (target, provider, dir) {
        return __awaiter(this, void 0, void 0, function () {
            var err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        logger.info('Initializing......');
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 6, , 7]);
                        if (!urlParser.isUrlFormat(target)) return [3 /*break*/, 3];
                        return [4 /*yield*/, this.downloadUrlTemplate(target, dir)];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 5];
                    case 3: return [4 /*yield*/, this.downloadAppTemplate(target, provider, dir)];
                    case 4:
                        _a.sent();
                        _a.label = 5;
                    case 5:
                        logger.success(msg.INIT_SUCCESS_TIPS);
                        return [3 /*break*/, 7];
                    case 6:
                        err_1 = _a.sent();
                        throw err_1;
                    case 7: return [2 /*return*/];
                }
            });
        });
    };
    InitManager.prototype.downloadAppTemplate = function (project, provider, dir) {
        return __awaiter(this, void 0, void 0, function () {
            var outputDir, err_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        outputDir = path.resolve(process.cwd(), dir || project);
                        if (fs.existsSync(outputDir)) {
                            throw new init_error_1.InitError('Directory already exists: {{{outputDir}}}', {
                                outputDir: outputDir
                            });
                        }
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, this.downloadManager.downloadTemplateFromAppCenter(package_type_1.PackageType.application, project, outputDir, provider)];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        err_2 = _a.sent();
                        throw err_2;
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    InitManager.prototype.downloadUrlTemplate = function (address, dir) {
        return __awaiter(this, void 0, void 0, function () {
            var url, repoTemplate, outputDir, err_3, outputDir, err_4;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        url = urlParser.parse(address);
                        if (!(url.protocol && (url.protocol.startsWith('https') || url.protocol.startsWith('http')))) return [3 /*break*/, 5];
                        if (!url.hostname || !url.hostname.includes('github')) {
                            throw new init_error_1.InitError('Unknown host({{host}}), we support github currently.', { host: url.host });
                        }
                        repoTemplate = urlParser.extractTemplateInfo(url);
                        outputDir = path.resolve(process.cwd(), dir || repoTemplate.repoName);
                        if (fs.existsSync(outputDir)) {
                            throw new init_error_1.InitError('Directory already exists: {{{outputDir}}}', {
                                outputDir: outputDir
                            });
                        }
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, this.downloadManager.downloadTemplateByUrl(repoTemplate, outputDir)];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        err_3 = _a.sent();
                        throw err_3;
                    case 4: return [3 /*break*/, 11];
                    case 5:
                        if (!url.href.startsWith('git@')) return [3 /*break*/, 10];
                        outputDir = path.resolve(process.cwd(), dir || urlParser.getProjectNameFromUrl(url.href));
                        if (fs.existsSync(outputDir)) {
                            throw new init_error_1.InitError('Directory already exists: {{{outputDir}}}', {
                                outputDir: outputDir
                            });
                        }
                        _a.label = 6;
                    case 6:
                        _a.trys.push([6, 8, , 9]);
                        return [4 /*yield*/, this.downloadManager.downloadTemplateByGitClone(url, outputDir)];
                    case 7:
                        _a.sent();
                        return [3 /*break*/, 9];
                    case 8:
                        err_4 = _a.sent();
                        throw new init_error_1.InitError('Git clone Template failed: {{msg}}', {
                            msg: err_4.message
                        });
                    case 9: return [3 /*break*/, 11];
                    case 10: throw new init_error_1.InitError('Unknown project format: {{target}}', {
                        target: url.href
                    });
                    case 11: return [2 /*return*/];
                }
            });
        });
    };
    return InitManager;
}());
exports.InitManager = InitManager;
//# sourceMappingURL=init-manager.js.map