"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DownloadManager = void 0;
var path = require("path");
var download = require("download");
var os = require("os");
var fs = require("fs-extra");
var axios_1 = require("axios");
var inquirer = require("inquirer");
var init_error_1 = require("../error/init-error");
var ChildProcess = require("child_process");
var util = require("util");
var logger_1 = require("../utils/logger");
var package_type_1 = require("../utils/package-type");
var i18n_1 = require("./i18n");
var static_variable_1 = require("../constants/static-variable");
// eslint-disable-next-line no-unused-vars
var s_progress_bar_1 = require("@serverless-devs/s-progress-bar");
var got = require('got');
var colors_1 = require("colors");
var DownloadManager = /** @class */ (function () {
    function DownloadManager() {
    }
    /**
       * Download template from app center
       * @param packageType: package type, such as application, component or plugin
       * @param packageName: package name
       * @param outputDir: outputDir
       * @param provider: package provider, will promopt if not given
       */
    DownloadManager.prototype.downloadTemplateFromAppCenter = function (packageType, packageName, outputDir, provider) {
        return __awaiter(this, void 0, void 0, function () {
            var err_1, url, err_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!(packageType !== package_type_1.PackageType.plugin && !provider)) return [3 /*break*/, 4];
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, this.getPackageProvider(packageType, packageName)];
                    case 2:
                        provider = _a.sent();
                        logger_1.default.info('  Init Information:');
                        logger_1.default.info(i18n_1.default.__("    Package: {{package}}    Provider: {{provider}}", { 'package': packageName, 'provider': provider }));
                        return [3 /*break*/, 4];
                    case 3:
                        err_1 = _a.sent();
                        throw new init_error_1.InitError(err_1.message);
                    case 4:
                        _a.trys.push([4, 7, , 8]);
                        return [4 /*yield*/, this.getPackageDownloadUrl(packageType, packageName, provider)];
                    case 5:
                        url = _a.sent();
                        return [4 /*yield*/, this.downloadTemplateByUrl({
                                zipFile: url,
                                hasSubPath: false
                            }, outputDir)];
                    case 6:
                        _a.sent();
                        return [3 /*break*/, 8];
                    case 7:
                        err_2 = _a.sent();
                        throw err_2;
                    case 8: return [2 /*return*/];
                }
            });
        });
    };
    DownloadManager.prototype.downloadTemplateByUrl = function (template, outputDir) {
        return __awaiter(this, void 0, void 0, function () {
            var uuid, srcDirName, err_3, srcSubDirName, destSubDirName;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        uuid = this.generateUUID();
                        srcDirName = path.join(os.tmpdir(), "" + uuid);
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, this.proxyDownload(template.zipFile, srcDirName, { extract: true, strip: 1 })];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        err_3 = _a.sent();
                        throw new init_error_1.InitError('Download template by url failed, error: {{msg}}', { msg: err_3.message });
                    case 4:
                        if (!template.hasSubPath) {
                            fs.copySync(srcDirName, outputDir, { dereference: true });
                        }
                        else {
                            srcSubDirName = path.join(srcDirName, template.subPath || '');
                            destSubDirName = path.join(outputDir, template.subPath || '');
                            fs.copySync(srcSubDirName, destSubDirName, { dereference: true });
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    DownloadManager.prototype.downloadTemplateByGitClone = function (url, outputDir) {
        return __awaiter(this, void 0, void 0, function () {
            var cmd, exec, err_4;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        cmd = "git clone " + url.href + " " + outputDir;
                        exec = util.promisify(ChildProcess.exec);
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, exec(cmd)];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        err_4 = _a.sent();
                        throw err_4;
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    DownloadManager.prototype.getPackageProvider = function (packageType, project) {
        return __awaiter(this, void 0, void 0, function () {
            var options, result, err_5, providers, provider_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        options = {
                            url: static_variable_1.SERVERLESS_GET_PACKAGE_PROVIDER,
                            type: 'get',
                            timeout: 5000,
                            headers: {},
                            params: {
                                name: project,
                                type: package_type_1.PackageType[packageType]
                            }
                        };
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, axios_1.default.request(options)];
                    case 2:
                        result = _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        err_5 = _a.sent();
                        throw new init_error_1.InitError('Failed to get package provider, error: {{msg}}', { msg: err_5.message });
                    case 4:
                        if (result.status !== 200) {
                            throw new init_error_1.InitError('Failed to get package provider, http code: {{code}}', { code: result.status });
                        }
                        if (result.data.Error) {
                            throw new init_error_1.InitError('Failed to get package provider, error message: {{msg}}', { msg: result.data.Error });
                        }
                        providers = result.data.Response.Providers;
                        if (!providers || providers.length === 0) {
                            throw new init_error_1.InitError('No available provider for {{project}}', { project: project });
                        }
                        if (!(providers.length === 0)) return [3 /*break*/, 5];
                        throw new init_error_1.InitError('Could not get package.');
                    case 5:
                        if (!(providers.length === 1)) return [3 /*break*/, 6];
                        return [2 /*return*/, providers[0]];
                    case 6: return [4 /*yield*/, inquirer.prompt([
                            {
                                type: 'list',
                                name: 'provider',
                                message: i18n_1.default.__('Please choose a provider'),
                                choices: providers
                            }
                        ])];
                    case 7:
                        provider_1 = (_a.sent()).provider;
                        return [2 /*return*/, new Promise(function (resolve, reject) {
                                resolve(provider_1);
                            })];
                }
            });
        });
    };
    DownloadManager.prototype.getPackageDownloadUrl = function (packageType, packageName, provider) {
        return __awaiter(this, void 0, void 0, function () {
            var options, result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        options = {
                            url: static_variable_1.SERVERLESS_GET_APP_INFO_URL,
                            type: 'get',
                            timeout: 5000,
                            headers: {
                                'User-Agent': 's'
                            },
                            params: {
                                name: packageName,
                                provider: provider,
                                type: package_type_1.PackageType[packageType]
                            }
                        };
                        return [4 /*yield*/, axios_1.default.request(options)];
                    case 1:
                        result = _a.sent();
                        if (result.status !== 200) {
                            throw new init_error_1.InitError('Failed to get package information, http code: {{code}}', { code: result.status });
                        }
                        if (!result.data.Response) {
                            throw new init_error_1.InitError('Failed to get package information, error: {{msg}}', { msg: result.data.Response || i18n_1.default.__('Please try again later') });
                        }
                        return [2 /*return*/, new Promise(function (resolve, reject) {
                                resolve(result.data.Response.Url);
                            })];
                }
            });
        });
    };
    DownloadManager.prototype.generateUUID = function () {
        return Math.random().toString(36).substring(2, 15) + Math.random().toString(36).substring(2, 15);
    };
    DownloadManager.prototype.proxyDownload = function (url, dest, options) {
        return __awaiter(this, void 0, void 0, function () {
            var len, headers, err_6, bar, pbo, pbo, format;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, got(url, { method: 'HEAD' })];
                    case 1:
                        headers = (_a.sent()).headers;
                        len = parseInt(headers['content-length'], 10);
                        return [3 /*break*/, 3];
                    case 2:
                        err_6 = _a.sent();
                        return [3 /*break*/, 3];
                    case 3:
                        if (len) {
                            pbo = {
                                total: len
                            };
                            bar = new s_progress_bar_1.ProgressService(s_progress_bar_1.ProgressType.Bar, pbo);
                        }
                        else {
                            pbo = {
                                total: 100,
                                width: 0
                            };
                            format = colors_1.green(':loading') + " " + colors_1.green(i18n_1.default.__('Downloading ...')) + " ";
                            bar = new s_progress_bar_1.ProgressService(s_progress_bar_1.ProgressType.Loading, pbo, format);
                        }
                        return [4 /*yield*/, download(url, dest, options).on('downloadProgress', function (progress) {
                                bar.update(progress.transferred);
                            })];
                    case 4:
                        _a.sent();
                        bar.terminate();
                        return [2 /*return*/];
                }
            });
        });
    };
    return DownloadManager;
}());
exports.DownloadManager = DownloadManager;
//# sourceMappingURL=download-manager.js.map