"use strict";
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.success = exports.warning = exports.info = exports.error = exports.debug = exports.log = exports.colorSwitch = void 0;
var serverless_error_1 = require("../error/serverless-error");
var i18n_1 = require("../utils/i18n");
var colors = require('colors');
var red = colors.red, white = colors.white, gray = colors.gray, cyan = colors.cyan, yellow = colors.yellow, green = colors.green;
// 输出信息颜色启用或关闭
exports.colorSwitch = function (flag) {
    process.env.COLORFLAG = "" + flag;
    if (flag) {
        colors.enable();
    }
    else {
        colors.disable();
    }
};
if (typeof process.env.COLORFLAG === 'string') {
    exports.colorSwitch(process.env.COLORFLAG === 'true');
}
/*
  debug 只有 debug 模式才可以输出
  error 判断是否属于 error 类型，error.messsage, debug 输出所有
*/
// 框架信息输出 白色
exports.log = function () {
    var e_1, _a;
    var message = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        message[_i] = arguments[_i];
    }
    try {
        for (var message_1 = __values(message), message_1_1 = message_1.next(); !message_1_1.done; message_1_1 = message_1.next()) {
            var m = message_1_1.value;
            console.log(white(i18n_1.default.__(m)));
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (message_1_1 && !message_1_1.done && (_a = message_1.return)) _a.call(message_1);
        }
        finally { if (e_1) throw e_1.error; }
    }
};
// 组件输出 灰色
exports.debug = function () {
    var message = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        message[_i] = arguments[_i];
    }
    if (process.env.VERBOSE) {
        console.log(gray.apply(void 0, __spread(message)));
    }
};
// 错误输出 红色
exports.error = function () {
    var e_2, _a;
    var message = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        message[_i] = arguments[_i];
    }
    try {
        for (var message_2 = __values(message), message_2_1 = message_2.next(); !message_2_1.done; message_2_1 = message_2.next()) {
            var m = message_2_1.value;
            if (typeof m === 'string' || m instanceof String) {
                console.log(red(i18n_1.default.__(m)));
            }
            else if (m instanceof serverless_error_1.ServerlessError) {
                //already i18n for serverless error
                console.log(red(m));
            }
            else if (m instanceof Error) {
                console.log(red(i18n_1.default.__(m.message)));
            }
        }
    }
    catch (e_2_1) { e_2 = { error: e_2_1 }; }
    finally {
        try {
            if (message_2_1 && !message_2_1.done && (_a = message_2.return)) _a.call(message_2);
        }
        finally { if (e_2) throw e_2.error; }
    }
    /*
    if (process.env.VERBOSE) {
      console.log(red(...message));
    } else {
      const m: any[] = message.map((item: any) => {
        if (item instanceof Error) {
          return item.message;
        }
        return item;
      });
      console.log(red(...m));
    }
    */
};
// 提醒信息 蓝色
exports.info = function () {
    var e_3, _a;
    var message = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        message[_i] = arguments[_i];
    }
    try {
        for (var message_3 = __values(message), message_3_1 = message_3.next(); !message_3_1.done; message_3_1 = message_3.next()) {
            var m = message_3_1.value;
            console.log(cyan(i18n_1.default.__(m)));
        }
    }
    catch (e_3_1) { e_3 = { error: e_3_1 }; }
    finally {
        try {
            if (message_3_1 && !message_3_1.done && (_a = message_3.return)) _a.call(message_3);
        }
        finally { if (e_3) throw e_3.error; }
    }
};
// 警告信息 黄色
exports.warning = function () {
    var e_4, _a;
    var message = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        message[_i] = arguments[_i];
    }
    try {
        for (var message_4 = __values(message), message_4_1 = message_4.next(); !message_4_1.done; message_4_1 = message_4.next()) {
            var m = message_4_1.value;
            console.log(yellow(i18n_1.default.__(m)));
        }
    }
    catch (e_4_1) { e_4 = { error: e_4_1 }; }
    finally {
        try {
            if (message_4_1 && !message_4_1.done && (_a = message_4.return)) _a.call(message_4);
        }
        finally { if (e_4) throw e_4.error; }
    }
};
// 成功信息 绿色
exports.success = function () {
    var e_5, _a;
    var message = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        message[_i] = arguments[_i];
    }
    try {
        for (var message_5 = __values(message), message_5_1 = message_5.next(); !message_5_1.done; message_5_1 = message_5.next()) {
            var m = message_5_1.value;
            console.log(green(i18n_1.default.__(m)));
        }
    }
    catch (e_5_1) { e_5 = { error: e_5_1 }; }
    finally {
        try {
            if (message_5_1 && !message_5_1.done && (_a = message_5.return)) _a.call(message_5);
        }
        finally { if (e_5) throw e_5.error; }
    }
};
exports.default = {
    info: exports.info, debug: exports.debug, error: exports.error, log: exports.log, warning: exports.warning, success: exports.success, colorSwitch: exports.colorSwitch
};
//# sourceMappingURL=logger.js.map