"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var express = require('express');
var execSync = require('child_process').execSync;
var logger_1 = require("./logger");
var StartService = /** @class */ (function () {
    function StartService(context) {
        this.context = context;
        this.port = 3000;
        this.counter = 0;
        this.app = express();
    }
    StartService.prototype.randomNum = function () {
        return 3000 + Math.round(Math.random() * 2000);
    };
    StartService.prototype.start = function () {
        var _a = this.context, callback = _a.callback, _b = _a.port, port = _b === void 0 ? 3000 : _b;
        this.port = port;
        callback(this.app);
        this.listen();
    };
    StartService.prototype.listen = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                this.counter += 1;
                this.server = this.app.listen(this.port, function () {
                    var uri = "http://localhost:" + _this.port;
                    logger_1.default.log(uri);
                    if (_this.context.openBrowser) {
                        var startInstruction = process.platform === 'win32' ? 'start' : 'open';
                        execSync(startInstruction + " " + uri);
                    }
                });
                this.server.on('error', function (e) {
                    if (e.code === 'EADDRINUSE') {
                        if (_this.counter < 5) {
                            _this.port = _this.randomNum();
                            _this.listen();
                        }
                        else {
                            logger_1.default.error(e);
                        }
                    }
                });
                return [2 /*return*/];
            });
        });
    };
    StartService.prototype.stop = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                this.server.close();
                return [2 /*return*/];
            });
        });
    };
    return StartService;
}());
exports.default = StartService;
//# sourceMappingURL=start-service.js.map